//Om Ganesayanamaha
package org.processmining.plugins.abstractions;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.abstractions.visualization.PatternAbstractionFrame;

/**
 * 
 * @author R. P. Jagadeesh Chandra 'JC' Bose
 * @date 15 May 2011 Eindhoven University of Technology (TU/e)
 * 
 *       Reproducing or using whole or part of this code/application is to be done with proper
 *       acknowledgments by citing "R. P. Jagadeesh Chandra Bose and Wil M. P.
 *       van der Aalst. Abstractions in Process Mining: A Taxonomy of Patterns.
 *       Proceedings of the International Conference on Business Process
 *       Management (BPM). Volume 5701 of LNCS., Springer-Verlag (2009) pages
 *       159-175"
 * 
 */

@Visualizer
@Plugin(name = "Pattern Abstractions (New)", parameterLabels = {"log"}, returnLabels = { "Pattern Abstractions" }, returnTypes = { PatternAbstractionFrame.class }, userAccessible = true, help = "Pattern Abstraction")
public class PatternAbstractionsPlugin {
	//@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "R.P. Jagadeesh Chandra 'JC' Bose", email = "j.c.b.rantham.prabhakara@tue.nl", website = "www.processmining.org")
	@PluginVariant(variantLabel = "Default Summary, user-specified clusters.", requiredParameterLabels = { 0 })
	public static PatternAbstractionFrame patternAbstractions(UIPluginContext context, XLog log) {
		// Set the look at feel for the alignment frame
		/*
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
		}
		*/
		PatternAbstractionFrame patternAbstractionFrame = new PatternAbstractionFrame(context, log);
//		context.addConnection(new PatternAbstractionsConnection(patternAbstractionFrame));
		return patternAbstractionFrame;
	}
}
