package org.processmining.plugins.abstractions.datatypes;

import java.util.Map;
import java.util.TreeSet;

/**
 * 
 * @author R. P. Jagadeesh Chandra 'JC' Bose
 * @date 15 May 2011 Eindhoven University of Technology (TU/e)
 * 
 *       Reproducing or using whole or part of this code/application is to be done with proper
 *       acknowledgments by citing "R. P. Jagadeesh Chandra Bose and Wil M. P.
 *       van der Aalst. Abstractions in Process Mining: A Taxonomy of Patterns.
 *       Proceedings of the International Conference on Business Process
 *       Management (BPM). Volume 5701 of LNCS., Springer-Verlag (2009) pages
 *       159-175"
 * 
 */

public class ConservednessMetric {
	Map<TreeSet<String>, Integer> combinedPatternAlphabetConservednessMap;
	Map<TreeSet<String>, Integer> combinedPatternAlphabetNonDuplicateConservednessMap;
	Map<TreeSet<String>, Integer> combinedBasePatternAlphabetConservednessMap;
	Map<TreeSet<String>, Integer> combinedBasePatternAlphabetNonDuplicateConservednessMap;
	
	Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetConservednessMap;
	Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetNonDuplicateConservednessMap;
	Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetConservednessMap;
	Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetNonDuplicateConservednessMap;
	
	Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetConservednessMap;
	Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetNonDuplicateConservednessMap;
	Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetConservednessMap;
	Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetNonDuplicateConservednessMap;
	
	public ConservednessMetric(){
		
	}
	
	public Map<TreeSet<String>, Integer> getCombinedPatternAlphabetConservednessMap() {
		return combinedPatternAlphabetConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getCombinedPatternAlphabetNonDuplicateConservednessMap() {
		return combinedPatternAlphabetNonDuplicateConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getCombinedBasePatternAlphabetConservednessMap() {
		return combinedBasePatternAlphabetConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getCombinedBasePatternAlphabetNonDuplicateConservednessMap() {
		return combinedBasePatternAlphabetNonDuplicateConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayPatternAlphabetConservednessMap() {
		return tandemArrayPatternAlphabetConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayPatternAlphabetNonDuplicateConservednessMap() {
		return tandemArrayPatternAlphabetNonDuplicateConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayBasePatternAlphabetConservednessMap() {
		return tandemArrayBasePatternAlphabetConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayBasePatternAlphabetNonDuplicateConservednessMap() {
		return tandemArrayBasePatternAlphabetNonDuplicateConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getMaximalRepeatPatternAlphabetConservednessMap() {
		return maximalRepeatPatternAlphabetConservednessMap;
	}

	public Map<TreeSet<String>, Integer> getMaximalRepeatPatternAlphabetNonDuplicateConservednessMap() {
		return maximalRepeatPatternAlphabetNonDuplicateConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getMaximalRepeatBasePatternAlphabetConservednessMap() {
		return maximalRepeatBasePatternAlphabetConservednessMap;
	}
	
	public Map<TreeSet<String>, Integer> getMaximalRepeatBasePatternAlphabetNonDuplicateConservednessMap() {
		return maximalRepeatBasePatternAlphabetNonDuplicateConservednessMap;
	}
	
	public void setCombinedPatternAlphabetConservednessMap(
			Map<TreeSet<String>, Integer> combinedPatternAlphabetConservednessMap) {
		this.combinedPatternAlphabetConservednessMap = combinedPatternAlphabetConservednessMap;
	}
	
	public void setCombinedPatternAlphabetNonDuplicateConservednessMap(
			Map<TreeSet<String>, Integer> combinedPatternAlphabetNonDuplicateConservednessMap) {
		this.combinedPatternAlphabetNonDuplicateConservednessMap = combinedPatternAlphabetNonDuplicateConservednessMap;
	}
	
	public void setCombinedBasePatternAlphabetConservednessMap(
			Map<TreeSet<String>, Integer> combinedBasePatternAlphabetConservednessMap) {
		this.combinedBasePatternAlphabetConservednessMap = combinedBasePatternAlphabetConservednessMap;
	}
	
	public void setCombinedBasePatternAlphabetNonDuplicateConservednessMap(
			Map<TreeSet<String>, Integer> combinedBasePatternAlphabetNonDuplicateConservednessMap) {
		this.combinedBasePatternAlphabetNonDuplicateConservednessMap = combinedBasePatternAlphabetNonDuplicateConservednessMap;
	}
	
	public void setTandemArrayPatternAlphabetConservednessMap(
			Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetConservednessMap) {
		this.tandemArrayPatternAlphabetConservednessMap = tandemArrayPatternAlphabetConservednessMap;
	}
	
	public void setTandemArrayPatternAlphabetNonDuplicateConservednessMap(
			Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetNonDuplicateConservednessMap) {
		this.tandemArrayPatternAlphabetNonDuplicateConservednessMap = tandemArrayPatternAlphabetNonDuplicateConservednessMap;
	}
	
	public void setTandemArrayBasePatternAlphabetConservednessMap(
			Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetConservednessMap) {
		this.tandemArrayBasePatternAlphabetConservednessMap = tandemArrayBasePatternAlphabetConservednessMap;
	}
	
	public void setTandemArrayBasePatternAlphabetNonDuplicateConservednessMap(
			Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetNonDuplicateConservednessMap) {
		this.tandemArrayBasePatternAlphabetNonDuplicateConservednessMap = tandemArrayBasePatternAlphabetNonDuplicateConservednessMap;
	}
	
	public void setMaximalRepeatPatternAlphabetConservednessMap(
			Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetConservednessMap) {
		this.maximalRepeatPatternAlphabetConservednessMap = maximalRepeatPatternAlphabetConservednessMap;
	}
	
	public void setMaximalRepeatPatternAlphabetNonDuplicateConservednessMap(
			Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetNonDuplicateConservednessMap) {
		this.maximalRepeatPatternAlphabetNonDuplicateConservednessMap = maximalRepeatPatternAlphabetNonDuplicateConservednessMap;
	}
	
	public void setMaximalRepeatBasePatternAlphabetConservednessMap(
			Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetConservednessMap) {
		this.maximalRepeatBasePatternAlphabetConservednessMap = maximalRepeatBasePatternAlphabetConservednessMap;
	}
	
	public void setMaximalRepeatBasePatternAlphabetNonDuplicateConservednessMap(
			Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetNonDuplicateConservednessMap) {
		this.maximalRepeatBasePatternAlphabetNonDuplicateConservednessMap = maximalRepeatBasePatternAlphabetNonDuplicateConservednessMap;
	}

	public void printMetrics(){
		System.out.println("Combined Pattern Conservedness");
		for(TreeSet<String> patternAlphabet : combinedPatternAlphabetConservednessMap.keySet()){
			System.out.print(patternAlphabet+" @ "+combinedPatternAlphabetConservednessMap.get(patternAlphabet)+" @ "+combinedPatternAlphabetNonDuplicateConservednessMap.get(patternAlphabet));
			if(combinedBasePatternAlphabetConservednessMap.containsKey(patternAlphabet))
				System.out.println(" @ "+combinedBasePatternAlphabetConservednessMap.get(patternAlphabet)+" @ "+combinedBasePatternAlphabetNonDuplicateConservednessMap.get(patternAlphabet));
			else
				System.out.println();
		}
		
		System.out.println("Tandem Array Pattern Conservedness");
		for(TreeSet<String> patternAlphabet : tandemArrayPatternAlphabetNonDuplicateConservednessMap.keySet()){
			System.out.print(patternAlphabet+" @ "+tandemArrayPatternAlphabetConservednessMap.get(patternAlphabet)+" @ "+tandemArrayPatternAlphabetNonDuplicateConservednessMap.get(patternAlphabet));
			if(tandemArrayBasePatternAlphabetConservednessMap.containsKey(patternAlphabet))
				System.out.println(" @ "+tandemArrayBasePatternAlphabetConservednessMap.get(patternAlphabet)+" @ "+tandemArrayBasePatternAlphabetNonDuplicateConservednessMap.get(patternAlphabet));
			else
				System.out.println();
		}

		System.out.println("Maximal Repeat Pattern Conservedness");
		for(TreeSet<String> patternAlphabet : maximalRepeatPatternAlphabetConservednessMap.keySet()){
			System.out.print(patternAlphabet+" @ "+maximalRepeatPatternAlphabetConservednessMap.get(patternAlphabet)+" @ "+maximalRepeatPatternAlphabetNonDuplicateConservednessMap.get(patternAlphabet));
			if(maximalRepeatBasePatternAlphabetConservednessMap.containsKey(patternAlphabet))
				System.out.println(" @ "+maximalRepeatBasePatternAlphabetConservednessMap.get(patternAlphabet)+" @ "+maximalRepeatBasePatternAlphabetNonDuplicateConservednessMap.get(patternAlphabet));
			else
				System.out.println();
		}
	}
}
