package org.processmining.plugins.abstractions.datatypes;

import java.util.Map;
import java.util.TreeSet;

import org.processmining.plugins.abstractions.util.Logger;

/**
 * 
 * @author R. P. Jagadeesh Chandra 'JC' Bose
 * @date 15 May 2011 Eindhoven University of Technology (TU/e)
 * 
 *       Reproducing or using whole or part of this code/application is to be done with proper
 *       acknowledgments by citing "R. P. Jagadeesh Chandra Bose and Wil M. P.
 *       van der Aalst. Abstractions in Process Mining: A Taxonomy of Patterns.
 *       Proceedings of the International Conference on Business Process
 *       Management (BPM). Volume 5701 of LNCS., Springer-Verlag (2009) pages
 *       159-175"
 * 
 */
public class MetricPatternAlphabetCount {
	Map<TreeSet<String>, TreeSet<String>> contributingTandemArrayPatternAlphabetPatternSetMap;
	Map<TreeSet<String>, TreeSet<String>> contributingTandemArrayBasePatternAlphabetPatternSetMap;
	Map<TreeSet<String>, TreeSet<String>> contributingMaximalRepeatPatternAlphabetPatternSetMap;
	Map<TreeSet<String>, TreeSet<String>> contributingMaximalRepeatBasePatternAlphabetPatternSetMap;
	Map<TreeSet<String>, TreeSet<String>> contributingCombinedPatternAlphabetPatternSetMap;
	Map<TreeSet<String>, TreeSet<String>> contributingCombinedBasePatternAlphabetPatternSetMap;
	
	Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetCountMap;
	Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetCountMap;
	Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetInstanceCountMap;
	Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetInstanceCountMap;
	
	Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetCountMap;
	Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetCountMap;
	Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetInstanceCountMap;
	Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetInstanceCountMap;
	
	Map<TreeSet<String>, Integer> combinedPatternAlphabetCountMap;
	Map<TreeSet<String>, Integer> combinedBasePatternAlphabetCountMap;
	Map<TreeSet<String>, Integer> combinedPatternAlphabetInstanceCountMap;
	Map<TreeSet<String>, Integer> combinedBasePatternAlphabetInstanceCountMap;
	
	Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetNonDuplicateCountMap;
	Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetNonDuplicateCountMap;
	Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetNonDuplicateInstanceCountMap;
	Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap;
	
	Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetNonDuplicateCountMap;
	Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetNonDuplicateCountMap;
	Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetNonDuplicateInstanceCountMap;
	Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap;
	
	Map<TreeSet<String>, Integer> combinedPatternAlphabetNonDuplicateCountMap;
	Map<TreeSet<String>, Integer> combinedBasePatternAlphabetNonDuplicateCountMap;
	Map<TreeSet<String>, Integer> combinedPatternAlphabetNonDuplicateInstanceCountMap;
	Map<TreeSet<String>, Integer> combinedBasePatternAlphabetNonDuplicateInstanceCountMap;
	
	public MetricPatternAlphabetCount(){
		
	}
	
	public void setTandemArrayPatternAlphabetCountMap(
			Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetCountMap) {
		this.tandemArrayPatternAlphabetCountMap = tandemArrayPatternAlphabetCountMap;
	}

	public void setTandemArrayBasePatternAlphabetCountMap(
			Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetCountMap) {
		this.tandemArrayBasePatternAlphabetCountMap = tandemArrayBasePatternAlphabetCountMap;
	}
	
	public void setTandemArrayPatternAlphabetInstanceCountMap(
			Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetInstanceCountMap) {
		this.tandemArrayPatternAlphabetInstanceCountMap = tandemArrayPatternAlphabetInstanceCountMap;
	}
	
	public void setTandemArrayBasePatternAlphabetInstanceCountMap(
			Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetInstanceCountMap) {
		this.tandemArrayBasePatternAlphabetInstanceCountMap = tandemArrayBasePatternAlphabetInstanceCountMap;
	}
	
	public void setMaximalRepeatPatternAlphabetCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetCountMap) {
		this.maximalRepeatPatternAlphabetCountMap = maximalRepeatPatternAlphabetCountMap;
	}
	
	public void setMaximalRepeatBasePatternAlphabetCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetCountMap) {
		this.maximalRepeatBasePatternAlphabetCountMap = maximalRepeatBasePatternAlphabetCountMap;
	}
	
	public void setMaximalRepeatPatternAlphabetInstanceCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetInstanceCountMap) {
		this.maximalRepeatPatternAlphabetInstanceCountMap = maximalRepeatPatternAlphabetInstanceCountMap;
	}
	
	public void setMaximalRepeatBasePatternAlphabetInstanceCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetInstanceCountMap) {
		this.maximalRepeatBasePatternAlphabetInstanceCountMap = maximalRepeatBasePatternAlphabetInstanceCountMap;
	}
	
	public void setCombinedPatternAlphabetCountMap(
			Map<TreeSet<String>, Integer> combinedPatternAlphabetCountMap) {
		this.combinedPatternAlphabetCountMap = combinedPatternAlphabetCountMap;
	}
	
	public void setCombinedBasePatternAlphabetCountMap(
			Map<TreeSet<String>, Integer> combinedBasePatternAlphabetCountMap) {
		this.combinedBasePatternAlphabetCountMap = combinedBasePatternAlphabetCountMap;
	}
	
	public void setCombinedPatternAlphabetInstanceCountMap(
			Map<TreeSet<String>, Integer> combinedPatternAlphabetInstanceCountMap) {
		this.combinedPatternAlphabetInstanceCountMap = combinedPatternAlphabetInstanceCountMap;
	}
	
	public void setCombinedBasePatternAlphabetInstanceCountMap(
			Map<TreeSet<String>, Integer> combinedBasePatternAlphabetInstanceCountMap) {
		this.combinedBasePatternAlphabetInstanceCountMap = combinedBasePatternAlphabetInstanceCountMap;
	}

	public void setTandemArrayPatternAlphabetNonDuplicateCountMap(
			Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetNonDuplicateCountMap) {
		this.tandemArrayPatternAlphabetNonDuplicateCountMap = tandemArrayPatternAlphabetNonDuplicateCountMap;
	}

	public void setTandemArrayBasePatternAlphabetNonDuplicateCountMap(
			Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetNonDuplicateCountMap) {
		this.tandemArrayBasePatternAlphabetNonDuplicateCountMap = tandemArrayBasePatternAlphabetNonDuplicateCountMap;
	}

	public void setTandemArrayPatternAlphabetNonDuplicateInstanceCountMap(
			Map<TreeSet<String>, Integer> tandemArrayPatternAlphabetNonDuplicateInstanceCountMap) {
		this.tandemArrayPatternAlphabetNonDuplicateInstanceCountMap = tandemArrayPatternAlphabetNonDuplicateInstanceCountMap;
	}

	public void setTandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap(
			Map<TreeSet<String>, Integer> tandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap) {
		this.tandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap = tandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap;
	}

	public void setMaximalRepeatPatternAlphabetNonDuplicateCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetNonDuplicateCountMap) {
		this.maximalRepeatPatternAlphabetNonDuplicateCountMap = maximalRepeatPatternAlphabetNonDuplicateCountMap;
	}

	public void setMaximalRepeatBasePatternAlphabetNonDuplicateCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetNonDuplicateCountMap) {
		this.maximalRepeatBasePatternAlphabetNonDuplicateCountMap = maximalRepeatBasePatternAlphabetNonDuplicateCountMap;
	}

	public void setMaximalRepeatPatternAlphabetNonDuplicateInstanceCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatPatternAlphabetNonDuplicateInstanceCountMap) {
		this.maximalRepeatPatternAlphabetNonDuplicateInstanceCountMap = maximalRepeatPatternAlphabetNonDuplicateInstanceCountMap;
	}

	public void setMaximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap(
			Map<TreeSet<String>, Integer> maximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap) {
		this.maximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap = maximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap;
	}

	public void setCombinedPatternAlphabetNonDuplicateCountMap(
			Map<TreeSet<String>, Integer> combinedPatternAlphabetNonDuplicateCountMap) {
		this.combinedPatternAlphabetNonDuplicateCountMap = combinedPatternAlphabetNonDuplicateCountMap;
	}

	public void setCombinedBasePatternAlphabetNonDuplicateCountMap(
			Map<TreeSet<String>, Integer> combinedBasePatternAlphabetNonDuplicateCountMap) {
		this.combinedBasePatternAlphabetNonDuplicateCountMap = combinedBasePatternAlphabetNonDuplicateCountMap;
	}

	public void setCombinedPatternAlphabetNonDuplicateInstanceCountMap(
			Map<TreeSet<String>, Integer> combinedPatternAlphabetNonDuplicateInstanceCountMap) {
		this.combinedPatternAlphabetNonDuplicateInstanceCountMap = combinedPatternAlphabetNonDuplicateInstanceCountMap;
	}

	public void setCombinedBasePatternAlphabetNonDuplicateInstanceCountMap(
			Map<TreeSet<String>, Integer> combinedBasePatternAlphabetNonDuplicateInstanceCountMap) {
		this.combinedBasePatternAlphabetNonDuplicateInstanceCountMap = combinedBasePatternAlphabetNonDuplicateInstanceCountMap;
	}

	public void setContributingTandemArrayPatternAlphabetPatternSetMap(
			Map<TreeSet<String>, TreeSet<String>> contributingTandemArrayPatternAlphabetPatternSetMap) {
		this.contributingTandemArrayPatternAlphabetPatternSetMap = contributingTandemArrayPatternAlphabetPatternSetMap;
	}

	public void setContributingTandemArrayBasePatternAlphabetPatternSetMap(
			Map<TreeSet<String>, TreeSet<String>> contributingTandemArrayBasePatternAlphabetPatternSetMap) {
		this.contributingTandemArrayBasePatternAlphabetPatternSetMap = contributingTandemArrayBasePatternAlphabetPatternSetMap;
	}

	public void setContributingMaximalRepeatPatternAlphabetPatternSetMap(
			Map<TreeSet<String>, TreeSet<String>> contributingMaximalRepeatPatternAlphabetPatternSetMap) {
		this.contributingMaximalRepeatPatternAlphabetPatternSetMap = contributingMaximalRepeatPatternAlphabetPatternSetMap;
	}

	public void setContributingMaximalRepeatBasePatternAlphabetPatternSetMap(
			Map<TreeSet<String>, TreeSet<String>> contributingMaximalRepeatBasePatternAlphabetPatternSetMap) {
		this.contributingMaximalRepeatBasePatternAlphabetPatternSetMap = contributingMaximalRepeatBasePatternAlphabetPatternSetMap;
	}

	public void setContributingCombinedPatternAlphabetPatternSetMap(
			Map<TreeSet<String>, TreeSet<String>> contributingCombinedPatternAlphabetPatternSetMap) {
		this.contributingCombinedPatternAlphabetPatternSetMap = contributingCombinedPatternAlphabetPatternSetMap;
	}

	public void setContributingCombinedBasePatternAlphabetPatternSetMap(
			Map<TreeSet<String>, TreeSet<String>> contributingCombinedBasePatternAlphabetPatternSetMap) {
		this.contributingCombinedBasePatternAlphabetPatternSetMap = contributingCombinedBasePatternAlphabetPatternSetMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayPatternAlphabetCountMap() {
		return tandemArrayPatternAlphabetCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayBasePatternAlphabetCountMap() {
		return tandemArrayBasePatternAlphabetCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayPatternAlphabetInstanceCountMap() {
		return tandemArrayPatternAlphabetInstanceCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getTandemArrayBasePatternAlphabetInstanceCountMap() {
		return tandemArrayBasePatternAlphabetInstanceCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getMaximalRepeatPatternAlphabetCountMap() {
		return maximalRepeatPatternAlphabetCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getMaximalRepeatBasePatternAlphabetCountMap() {
		return maximalRepeatBasePatternAlphabetCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getMaximalRepeatPatternAlphabetInstanceCountMap() {
		return maximalRepeatPatternAlphabetInstanceCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getMaximalRepeatBasePatternAlphabetInstanceCountMap() {
		return maximalRepeatBasePatternAlphabetInstanceCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getCombinedPatternAlphabetCountMap() {
		return combinedPatternAlphabetCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getCombinedBasePatternAlphabetCountMap() {
		return combinedBasePatternAlphabetCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getCombinedPatternAlphabetInstanceCountMap() {
		return combinedPatternAlphabetInstanceCountMap;
	}
	
	public Map<TreeSet<String>, Integer> getCombinedBasePatternAlphabetInstanceCountMap() {
		return combinedBasePatternAlphabetInstanceCountMap;
	}

	public Map<TreeSet<String>, Integer> getTandemArrayPatternAlphabetNonDuplicateCountMap() {
		return tandemArrayPatternAlphabetNonDuplicateCountMap;
	}

	public Map<TreeSet<String>, Integer> getTandemArrayBasePatternAlphabetNonDuplicateCountMap() {
		return tandemArrayBasePatternAlphabetNonDuplicateCountMap;
	}

	public Map<TreeSet<String>, Integer> getTandemArrayPatternAlphabetNonDuplicateInstanceCountMap() {
		return tandemArrayPatternAlphabetNonDuplicateInstanceCountMap;
	}

	public Map<TreeSet<String>, Integer> getTandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap() {
		return tandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap;
	}

	public Map<TreeSet<String>, Integer> getMaximalRepeatPatternAlphabetNonDuplicateCountMap() {
		return maximalRepeatPatternAlphabetNonDuplicateCountMap;
	}

	public Map<TreeSet<String>, Integer> getMaximalRepeatBasePatternAlphabetNonDuplicateCountMap() {
		return maximalRepeatBasePatternAlphabetNonDuplicateCountMap;
	}

	public Map<TreeSet<String>, Integer> getMaximalRepeatPatternAlphabetNonDuplicateInstanceCountMap() {
		return maximalRepeatPatternAlphabetNonDuplicateInstanceCountMap;
	}

	public Map<TreeSet<String>, Integer> getMaximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap() {
		return maximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap;
	}

	public Map<TreeSet<String>, Integer> getCombinedPatternAlphabetNonDuplicateCountMap() {
		return combinedPatternAlphabetNonDuplicateCountMap;
	}

	public Map<TreeSet<String>, Integer> getCombinedBasePatternAlphabetNonDuplicateCountMap() {
		return combinedBasePatternAlphabetNonDuplicateCountMap;
	}

	public Map<TreeSet<String>, Integer> getCombinedPatternAlphabetNonDuplicateInstanceCountMap() {
		return combinedPatternAlphabetNonDuplicateInstanceCountMap;
	}

	public Map<TreeSet<String>, Integer> getCombinedBasePatternAlphabetNonDuplicateInstanceCountMap() {
		return combinedBasePatternAlphabetNonDuplicateInstanceCountMap;
	}

	
	public Map<TreeSet<String>, TreeSet<String>> getContributingTandemArrayPatternAlphabetPatternSetMap() {
		return contributingTandemArrayPatternAlphabetPatternSetMap;
	}

	
	public Map<TreeSet<String>, TreeSet<String>> getContributingTandemArrayBasePatternAlphabetPatternSetMap() {
		return contributingTandemArrayBasePatternAlphabetPatternSetMap;
	}

	
	public Map<TreeSet<String>, TreeSet<String>> getContributingMaximalRepeatPatternAlphabetPatternSetMap() {
		return contributingMaximalRepeatPatternAlphabetPatternSetMap;
	}

	
	public Map<TreeSet<String>, TreeSet<String>> getContributingMaximalRepeatBasePatternAlphabetPatternSetMap() {
		return contributingMaximalRepeatBasePatternAlphabetPatternSetMap;
	}

	
	public Map<TreeSet<String>, TreeSet<String>> getContributingCombinedPatternAlphabetPatternSetMap() {
		return contributingCombinedPatternAlphabetPatternSetMap;
	}


	public Map<TreeSet<String>, TreeSet<String>> getContributingCombinedBasePatternAlphabetPatternSetMap() {
		return contributingCombinedBasePatternAlphabetPatternSetMap;
	}


	public void printMetrics(){
		System.out.println("Printing Tandem Array Metrics");
		for(TreeSet<String> patternAlphabet : tandemArrayPatternAlphabetCountMap.keySet()){
			System.out.print(patternAlphabet+" @ "+tandemArrayPatternAlphabetCountMap.get(patternAlphabet)+" @ "+tandemArrayPatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+tandemArrayPatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+tandemArrayPatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			if(tandemArrayBasePatternAlphabetCountMap.containsKey(patternAlphabet))
				System.out.println(" @ "+tandemArrayBasePatternAlphabetCountMap.get(patternAlphabet)+" @ "+tandemArrayBasePatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+tandemArrayBasePatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+tandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			else
				System.out.println();
		}
		
		System.out.println("\nPrinting Maximal Repeat Metrics");
		for(TreeSet<String> patternAlphabet : maximalRepeatPatternAlphabetCountMap.keySet()){
			System.out.print(patternAlphabet+" @ "+maximalRepeatPatternAlphabetCountMap.get(patternAlphabet)+" @ "+maximalRepeatPatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+maximalRepeatPatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+maximalRepeatPatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			if(maximalRepeatBasePatternAlphabetCountMap.containsKey(patternAlphabet))
				System.out.println(" @ "+maximalRepeatBasePatternAlphabetCountMap.get(patternAlphabet)+" @ "+maximalRepeatBasePatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+maximalRepeatBasePatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+maximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			else
				System.out.println();
		}
		
		System.out.println("\nPrinting Combined Pattern Metrics");
		for(TreeSet<String> patternAlphabet : combinedPatternAlphabetCountMap.keySet()){
			System.out.print(patternAlphabet+" @ "+combinedPatternAlphabetCountMap.get(patternAlphabet)+" @ "+combinedPatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+combinedPatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+combinedPatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			if(combinedBasePatternAlphabetCountMap.containsKey(patternAlphabet))
				System.out.println(" @ "+combinedBasePatternAlphabetCountMap.get(patternAlphabet)+" @ "+combinedBasePatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+combinedBasePatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+combinedBasePatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			else
				System.out.println();
		}
		
	}
	
	public void printMetricsLog(){
		Logger.println("Printing Tandem Array Metrics");
		for(TreeSet<String> patternAlphabet : tandemArrayPatternAlphabetCountMap.keySet()){
			Logger.print(patternAlphabet+" @ "+tandemArrayPatternAlphabetCountMap.get(patternAlphabet)+" @ "+tandemArrayPatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+tandemArrayPatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+tandemArrayPatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			if(tandemArrayBasePatternAlphabetCountMap.containsKey(patternAlphabet))
				Logger.println(" @ "+tandemArrayBasePatternAlphabetCountMap.get(patternAlphabet)+" @ "+tandemArrayBasePatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+tandemArrayBasePatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+tandemArrayBasePatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			else
				Logger.println("");
		}
		
		Logger.println("\nPrinting Maximal Repeat Metrics");
		for(TreeSet<String> patternAlphabet : maximalRepeatPatternAlphabetCountMap.keySet()){
			Logger.print(patternAlphabet+" @ "+maximalRepeatPatternAlphabetCountMap.get(patternAlphabet)+" @ "+maximalRepeatPatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+maximalRepeatPatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+maximalRepeatPatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			if(maximalRepeatBasePatternAlphabetCountMap.containsKey(patternAlphabet))
				Logger.println(" @ "+maximalRepeatBasePatternAlphabetCountMap.get(patternAlphabet)+" @ "+maximalRepeatBasePatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+maximalRepeatBasePatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+maximalRepeatBasePatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			else
				Logger.println("");
		}
		
		Logger.println("\nPrinting Combined Pattern Metrics");
		for(TreeSet<String> patternAlphabet : combinedPatternAlphabetCountMap.keySet()){
			Logger.print(patternAlphabet+" @ "+combinedPatternAlphabetCountMap.get(patternAlphabet)+" @ "+combinedPatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+combinedPatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+combinedPatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			if(combinedBasePatternAlphabetCountMap.containsKey(patternAlphabet))
				Logger.println(" @ "+combinedBasePatternAlphabetCountMap.get(patternAlphabet)+" @ "+combinedBasePatternAlphabetInstanceCountMap.get(patternAlphabet)+" @ "+combinedBasePatternAlphabetNonDuplicateCountMap.get(patternAlphabet)+" @ "+combinedBasePatternAlphabetNonDuplicateInstanceCountMap.get(patternAlphabet));
			else
				Logger.println("");
		}
		
	}
	
}
